

classes = {"CORE": [("ui.UILists", [("DecalLibsUIList", "")]),
                    ("properties", [("DecalLibsCollection", ""),
                                    ("DecalScalesCollection", ""),
                                    ("ExcludeCollection", ""),
                                    ("PreBakePreviewMaterialsCollection", "")]),
                    ("preferences", [("DECALmachinePreferences", "")]),
                    ("ui.operators.call_operator", [("CallDecalOperator", "call_decal_operator")]),
                    ("ui.operators.help", [("GetSupport", "get_decalmachine_support")]),
                    ("operators.libraries", [("Move", "move_decal_library"),
                                             ("Clear", "clear_decal_library"),
                                             ("Rename", "rename_decal_library"),
                                             ("Reload", "reload_decal_libraries"),
                                             ("Remove", "remove_decal_library"),
                                             ("ResetDecalsLocation", "reset_decals_location")]),
                    ("operators.pil", [("InstallPIL", "install_pil"),
                                       ("InstallPILAdmin", "install_pil_admin"),
                                       ("EasyInstallPILAdmin", "easy_install_pil_admin"),
                                       ("PurgePIL", "purge_pil")]),
                    ("properties", [("DecalSceneProperties", ""),
                                    ("DecalObjectProperties", ""),
                                    ("DecalMaterialProperties", ""),
                                    ("DecalImageProperties", ""),
                                    ("DecalCollectionProperties", "")])],

           "PIE_MENU": [("ui.pies", [("PieDecalMachine", "decal_machine")]),
                        ("ui.operators.scale", [("StoreIndividualDecalScale", "store_individual_decal_scale"),
                                                ("ClearIndividualDecalScale", "clear_individual_decal_scale"),
                                                ("Reset", "reset_decal_scale"),
                                                ("Set", "set_decal_scale")]),
                        ("ui.operators.call_pie", [("CallDecalPie", "call_decal_pie")])],

           "MENU": [("ui.menus", [("MenuDecalMachine", "decal_machine")])],


           "PANEL": [("ui.panels", [("PanelDECALmachine", "decal_machine")]),
                     ("ui.operators.match_material", [("UpdateMatchMaterials", "update_match_materials")]),
                     ("ui.operators.infotext", [("ResetOffsetPadding", "reset_infotext_offset_padding")])],

           "PANEL_CREATE": [("ui.panels", [("PanelDecalCreation", "decal_creation")])],
           "PANEL_EXPORT": [("ui.panels", [("PanelDecalExport", "decal_export")])],
           "PANEL_UPDATE_LEGACY": [("ui.panels", [("PanelUpdateLegacyDecalLibraries", "update_legacy_decal_libraries")])],
           "PANEL_HELP": [("ui.panels", [("PanelHelp", "help_decal_machine")])],


           "INSERTREMOVE": [("operators.insert_remove", [("Insert", "insert_decal"),
                                                         ("Remove", "remove_decal"),
                                                         ("QuickInsert", "quick_insert_decal"),
                                                         ("RemoveAllInstantDecals", "remove_all_instant_decals")])],
           "ADJUST": [("operators.adjust", [("Adjust", "adjust_decal")])],
           "REAPPLY": [("operators.reapply", [("ReApply", "reapply_decal")])],
           "PROJECT": [("operators.project", [("Project", "project_decal"),
                                              ("UnShrinkwrap", "unshrinkwrap_decal")])],
           "SLICE": [("operators.slice", [("Slice", "slice_decal")]),
                     ("operators.gpanel", [("GPanel", "gpanel")]),
                     ("operators.epanel", [("EPanel", "epanel")])],
           "GETBACKUP": [("operators.backup", [("GetBackup", "get_backup_decal")])],
           "PANELCUTTING": [("operators.cutting", [("PanelCutting", "panel_cutting"),
                                                   ("RemoveMeshCuts", "remove_mesh_cuts")]),
                            ("operators.draw.draw_meshcut", [("DrawMeshCut", "draw_meshcut")])],

           "UNWRAP": [("operators.unwrap", [("Unwrap", "panel_decal_unwrap")])],
           "MATCH": [("operators.match", [("Match", "match_material")])],
           "SELECT": [("operators.select", [("Select", "select_decals")])],

           "CREATE": [("operators.create", [("Create", "create_decal"),
                                            ("BatchCreate", "batch_create_decals"),
                                            ("LoadImages", "load_images"),
                                            ("ClearImages", "clear_images"),
                                            ("LoadFonts", "load_fonts"),
                                            ("ClearFonts", "clear_fonts"),
                                            ("AddDecalToLibrary", "add_decal_to_library"),
                                            ("UpdateLegacyDecalLibrary", "update_legacy_decal_library")])],

           "BAKE": [("operators.bake", [("Bake", "bake_decals"),
                                        ("RestorePreBakePreviewMaterials", "restore_pre_bakepreview_materialsi")])],

           "UTILS": [("operators.utils", [("FixTexturePaths", "fix_decal_texture_paths"),
                                          ("Validate", "validate_decal"),
                                          ("ClearProps", "clear_decal_props"),
                                          ("RemoveOrphans", "remove_decal_orphans")])],

           "INITGENUVS": [("operators.init_generated_uvs", [("InitGeneratedUVs", "init_generated_uvs")])],

           "ADDON": [("operators.addon", [("GroupProDissolve", "grouppro_dissolve")])],

           "DEBUG": [("operators.debug", [("FixLegacyNormals", "fix_legacy_normals"),
                                          ("ReRenderThumbnails", "rerender_decal_thumbnails"),
                                          ("UpdateNodeTree", "update_decal_node_tree"),
                                          # ("DebugWhatever", "debug_whatever"),
                                          ("ReplaceMaterial", "replace_material"),
                                          ("SetPropsAndNameFromMaterial", "set_props_and_name_from_material"),
                                          ("UpdateDecalBackup", "update_decal_backup"),
                                          ("DebugToggle", "decalmachine_debug")])],
           }


keys = {"PIE_MENU": [{"label": "3D View",
                      "keymap": "Object Mode",
                      "idname": "machin3.call_decal_pie",
                      "type": "D",
                      "value": "PRESS",
                      "properties": [("idname", "decal_machine")]}],
        "QUICK_INSERT": [{"label": "3D View",
                          "keymap": "Object Mode",
                          "idname": "machin3.call_decal_operator",
                          "type": "D",
                          "value": "PRESS",
                          "ctrl": True,
                          "properties": [("idname", "quick_insert_decal"),
                                         ("isinvoke", True)]}],
        "SELECT": [{"label": "3D View",
                    "keymap": "Object Mode",
                    "idname": "machin3.select_decals",
                    "type": "LEFTMOUSE",
                    "value": "DOUBLE_CLICK",
                    "info": ["For multiple objects, double-click in the background", "Users of the 2.80 keymap and users selecting with RIGHTMOUSE: consider remapping this"]}],
        }

